/*
TrussTopologyRobustRedundant - berechne_gleichungen

Author: Daniel Mohr
Date: 2012-02-29
*/

#include "ttrr_berechne_gleichungen.h"

void berechne_gleichungen(struct sparse_matrix *Aeq,struct double_vektor *beq,const int redundanz,const struct sparse_matrix *kraefte,const struct int_matrix *staebe,const struct double_vektor *laengen,const struct sparse_matrix *C)
{
  int red = abs(redundanz);
  int nx; /* Anzahl binaerer Variablen */
  int nw; /* Anzahl innerer Stabkraefte */
  int ns; /* Anzahl Stabdicken */
  int l,r,i;
  printf("berechne Gleichungen...");fflush(NULL);
  if (red == 0)
    red = 1;
  nx = abs(redundanz) * staebe->n; /* Anzahl binaerer Variablen */
  nw = kraefte->m * red * staebe->n; /* Anzahl innerer Stabkraefte */
  ns = red * staebe->n; /* Anzahl Stabdicken */
  /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
  Aeq->n = kraefte->m * red * C->n; /* Anzahl Zeilen */
  Aeq->m = nx + nw + ns; /* Anzahl Spalten */
  Aeq->nz = red * kraefte->m * C->nz; /* Anzahl Nicht-Null-Elemente */
  definiere_sparse_matrix(Aeq);
  beq->n = Aeq->n;
  beq->val = (double*)calloc(beq->n,sizeof(double));assert(beq->val != NULL);
  Aeq->i = 0;
  for(l = 0; l < kraefte->m; l++) /* fuer alle Lastfaelle */
    for(r = 0; r < red; r++) /* fuer alle Teilstrukturen */
      {
	for(i = 0; i < C->nz; i++) /* fuer alle Nicht-Null-Elemente von C */
	  {
	    Aeq->ia[Aeq->i] = l * red * C->n + r * C->n + C->ia[i];
	    Aeq->ja[Aeq->i] = nx + l * red * staebe->n + r * staebe->n + C->ja[i];
	    Aeq->ar[Aeq->i] = C->ar[i];
	    Aeq->i++;
	  }
	for(i = 0; i < kraefte->nz; i++)
	  if (kraefte->ja[i] == l)
	    beq->val[l * red * C->n + r * C->n + kraefte->ia[i]] = kraefte->ar[i];
      }
  printf("%d Gleichungen fuer %d Unbekannte berechnet (%d Nicht-Null-Elemente)\n",Aeq->n,Aeq->m,Aeq->nz);
}
