/*
TrussTopologyRobustRedundant - berechne_lb_ub

Author: Daniel Mohr
Date: 2012-02-29
*/

#include "ttrr_berechne_lb_ub.h"

void berechne_lb_ub(struct double_vektor *lb,struct double_vektor *ub,const int redundanz,const struct sparse_matrix *kraefte,const struct int_matrix *staebe,const struct double_vektor *laengen,const double sigmamin,const double sigmamax,const double smax)
{
  int red = abs(redundanz);
  int nx; /* Anzahl binaerer Variablen */
  int nw; /* Anzahl innerer Stabkraefte */
  int ns; /* Anzahl Stabdicken */
  int i;
  if (red == 0)
    {
      red = 1;
    }
  nx = abs(redundanz) * staebe->n; /* Anzahl binaerer Variablen */
  nw = kraefte->m * red * staebe->n; /* Anzahl innerer Stabkraefte */
  ns = red * staebe->n; /* Anzahl Stabdicken */
  printf("berechne lb und ub...");fflush(NULL);
  lb->n = nx + nw + ns;
  lb->val = (double*)calloc(lb->n,sizeof(double));assert(lb->val != NULL);
  ub->n = lb->n;
  ub->val = (double*)calloc(ub->n,sizeof(double));assert(ub->val != NULL);
  lb->i = 0;
  /* 0 <= x_i <= 1 */
  for(i = 0; i < nx; i++)
    {
      lb->val[lb->i] = 0;
      ub->val[lb->i] = 1.0;
      lb->i++;
    }
  /* sigmamin smax <= w_i <= sigmamax smax */
  for(i = 0; i < nw; i++)
    {
      lb->val[lb->i] = sigmamin * smax;
      ub->val[lb->i] = sigmamax * smax;
      lb->i++;
    }
  /* 0 <= s_i <= smax */
  for(i = 0; i < ns; i++)
    {
      lb->val[lb->i] = 0;
      ub->val[lb->i] = smax;
      lb->i++;
    }
  ub->i = lb->i;
  printf("lb und ub berechnet\n");
}
