/*
TrussTopologyRobustRedundant - cb_mip_greedy

Author: Daniel Mohr
Date: 2012-02-29

call back routine for glpk
*/

#include "ttrr_cb_mip_greedy.h"

void cb_mip_greedy(glp_tree *tree, void *info)
{
  glp_prob *llp;
  int index,i;
  glp_attr attr;
  double maxwert,w1,w2,w;
  /* struct cb_info *cb_info = static_cast<struct cb_info> info; */
  struct cb_info *cb_info = (struct cb_info*) info;
  switch (glp_ios_reason(tree))
    {
    case GLP_IBRANCH: /* request for branching */
      if ((glp_ios_mip_gap(tree) == DBL_MAX) && (cb_info->opt >= 3))
	{ /* request for branching + no integer solution exists */
	  llp = glp_ios_get_prob(tree);
	  glp_ios_row_attr(tree,1,&attr); /* hole informationen der ersten Zeile */
	  index = -1;
	  maxwert = -1;
	  for (i=1; i<=glp_get_num_cols(llp); i++) /* alle moegichen variablen */
	    if ((glp_ios_can_branch(tree,i) != 0) && (glp_get_col_kind(llp,i) == GLP_BV))
	      {	/* Variable ist branch-faehig + Variable ist binaer */
		/* glp_get_col_stat(llp,i) = GLP_BS (basic variable) */
		w1 = glp_get_col_prim(llp,i + cb_info->nx + cb_info->nw); /* Stabdicke */
		w2 = glp_get_obj_coef(llp,i + cb_info->nx + cb_info->nw); /* Stablaenge */
		w = w1*w2;
		if (maxwert < w) { maxwert = w; index = i; }
	      }
	  if (index > 0) glp_ios_branch_upon(tree,index,GLP_UP_BRNCH);
	} else { /* request for branching + integer solution exists */
	if (cb_info->opt == 5) /* search greedy-solution and stop */
	  glp_ios_terminate(tree);
      }
      break;
    case GLP_IBINGO:
      /* better integer solution found */
      cb_info->mipsols++;
      if (cb_info->opt == 4) /* search greedy-solution, write greedy solution and go on */
	{
	  llp = glp_ios_get_prob(tree);
	  hole_mip_solution(&cb_info->solution,&cb_info->x,&cb_info->w,&cb_info->s,llp);
	  schreibe_lp_solution(cb_info->pfad,llp,"tmp",cb_info->n,cb_info->opt);
	  schreibe_int_vektor(cb_info->pfad,"tmp_x",&cb_info->x);
	  schreibe_double_vektor(cb_info->pfad,"tmp_w",&cb_info->w);
	  schreibe_double_vektor(cb_info->pfad,"tmp_s",&cb_info->s);
	}
      break;
    default:
      /* ignore call for other reasons */
      break;
    }
  return;
}
