/*
TrussTopologyRobustRedundant - geometriematrix_stablaengen

Author: Daniel Mohr
Date: 2012-02-29
*/

#include "ttrr_geometriematrix_stablaengen.h"

void geometriematrix_stablaengen(struct sparse_matrix *C,struct double_vektor *laengen,const struct double_matrix *knoten,const struct int_matrix *staebe)
{
  int a,b;
  long double dx,dy,dz,r;
  int dim = knoten->m;
  int s;
  /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
  printf("berechne Geometriematrix und Stablaengen...");fflush(NULL);
  laengen->n = staebe->n;
  laengen->val = (double*)calloc(laengen->n,sizeof(double));assert(laengen->val != NULL);
  C->n = dim * knoten->n;
  C->m = staebe->n;
  C->nz = staebe->n * 2 * dim;
  C->ia = (int*)calloc(C->nz,sizeof(int));assert(C->ia != NULL);
  C->ja = (int*)calloc(C->nz,sizeof(int));assert(C->ja != NULL);
  C->ar = (double*)calloc(C->nz,sizeof(double));assert(C->ar != NULL);
  C->i = 0;
  for(s = 0; s < staebe->n; s++)
    {
      a = staebe->val[s][0];
      b = staebe->val[s][1];
      berechne_abstaende(&dx,&dy,&dz,a,b,knoten,staebe);
      r = sqrtl(squarel(dx)+squarel(dy)+squarel(dz));
      laengen->val[s] = r;
      /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
      if (dx!=0) {C->ia[C->i]=dim*a;   C->ja[C->i]=s; C->ar[C->i] = dx/r;  C->i++;}
      if (dy!=0) {C->ia[C->i]=dim*a+1; C->ja[C->i]=s; C->ar[C->i] = dy/r;  C->i++;}
      if (dx!=0) {C->ia[C->i]=dim*b;   C->ja[C->i]=s; C->ar[C->i] = -dx/r; C->i++;}
      if (dy!=0) {C->ia[C->i]=dim*b+1; C->ja[C->i]=s; C->ar[C->i] = -dy/r; C->i++;}
      if (dim > 2)
	{
	  if (dz!=0) {C->ia[C->i]=dim*a+2; C->ja[C->i]=s; C->ar[C->i] = dz/r;  C->i++;}
	  if (dz!=0) {C->ia[C->i]=dim*b+2; C->ja[C->i]=s; C->ar[C->i] = -dz/r; C->i++;}
	}
      /* printf("C(%d,%d) = %e\n",C->ia[C->i-1],C->ja[C->i-1],C->ar[C->i-1]); */
    }
  /* printf("[%dx%d mit %d Nicht-Null-Elemente]",C->n,C->m,C->nz); */
  if ( C->i < C->nz)
    {
      C->nz = C->i;
      C->ia = (int*)realloc(C->ia,C->nz * sizeof(int));assert(C->ia != NULL);
      C->ja = (int*)realloc(C->ja,C->nz * sizeof(int));assert(C->ja != NULL);
      C->ar = (double*)realloc(C->ar,C->nz * sizeof(double));assert(C->ar != NULL);
    }
  printf("Geometriematrix (%d Nicht-Null-Elemente) und Stablaengen berechnet\n",C->nz);
}
