/*
TrussTopologyRobustRedundant - skaliere_steilster_abstieg

Author: Daniel Mohr
Date: 2012-02-29

Dies funktioniert nicht wirklich

  skaliere(&alpha,&beta,&gamma,&A,&b,&Aeq,&beq,&lb,&ub,&z,redundanz,&staebe,&kraefte,sigma,&C,smax);
  printf("--> skaliere mit: alpha = %e; beta = %e; gamma = %e\n",alpha,beta,gamma);
  scale(fs,fz,&A,&b,&Aeq,&beq,&lb,&ub,&z);
*/

#include "ttrr_skaliere_steilster_abstieg.h"

double skaliere_berechne_faktoren_intern(const double x,const double y,const double z,const double a,const double b,const double c)
{
  return square(x*a-1) + square(y*b-1) + square(x*z*c-1) + square(y*z-1);
}

void skaliere_berechne_faktoren(double *alpha,double *beta,double *gamma,const double a,const double b,const double c)
{
  double x,y,z,f,step,minstep;
  double xn,yn,zn,fn;
  double fa;
  int s;
  int maxstep;
  printf("################ skaliere_berechne_faktoren ################ start ################\n");
  x = *alpha; y = *beta; z = *gamma;
  f = skaliere_berechne_faktoren_intern(x,y,z,a,b,c);
  printf("x = %e; y = %e; z = %e;    f = %e\n",x,y,z,f);
  step = sqrt(x*x+y*y+z*z)*10;
  minstep=x*x; if (y*y<minstep) minstep=y*y; if (z*z<minstep) minstep=z*z;
  minstep=sqrt(minstep)*1e-6;
  printf("start: fabs(step) = fabs(%e) = %e > minstep = %e\n",step,fabs(step),minstep);
  s = 0;
  maxstep = 10000000;
  while ((fabs(step) > minstep) && (s<maxstep))
    {
      step = -step/2;
      fa = f+1;
      while ((f < fa) && (s<maxstep))
	{
	  fa = f;
	  xn = x + step; fn = skaliere_berechne_faktoren_intern(xn,y,z,a,b,c);
	  while ((fn < f) && (s<maxstep))
	    {s++; f=fn; x=xn; xn=x+step; fn=skaliere_berechne_faktoren_intern(xn,y,z,a,b,c);}
	  yn = y + step; fn = skaliere_berechne_faktoren_intern(x,yn,z,a,b,c);
	  while ((fn < f) && (s<maxstep))
	    {s++; f=fn; y=yn; yn=y+step; fn=skaliere_berechne_faktoren_intern(x,yn,z,a,b,c);}
	  zn = z + step; fn = skaliere_berechne_faktoren_intern(x,y,zn,a,b,c);
	  while ((fn < f) && (s<maxstep))
	    {s++; f=fn; z=zn; zn=z+step; fn=skaliere_berechne_faktoren_intern(x,y,zn,a,b,c);}
	}
      /* printf("x = %e; y = %e; z = %e;    f = %e;    step = %e\n",x,y,z,f,step); */
    }
  printf("fertig: fabs(step) = fabs(%e) = %e <= minstep = %e\n",step,fabs(step),minstep);
  printf("x = %e; y = %e; z = %e;    f = %e\n",x,y,z,f);
  *alpha = x; *beta = y; *gamma = z;
  printf("################ skaliere_berechne_faktoren ################ ende ################\n");
}

void skaliere(double *alpha,double *beta,double *gamma,struct sparse_matrix *A,struct double_vektor *b,struct sparse_matrix *Aeq,struct double_vektor *beq,struct double_vektor *lb,struct double_vektor *ub,struct double_vektor *z,const int redundanz,const struct int_matrix *staebe,const struct sparse_matrix *kraefte,const double sigma,const struct sparse_matrix *C,const double smax)
{
  int nx; /* Anzahl binaerer Variablen */
  int nw; /* Anzahl innerer Stabkraefte */
  int ns; /* Anzahl Stabdicken */
  int i;
  unsigned char isred;
  double kraefte_norm;
  nx = abs(redundanz) * staebe->n; /* Anzahl binaerer Variablen */
  if (redundanz != 0)
    {
      nw = kraefte->m * abs(redundanz) * staebe->n; /* Anzahl innerer Stabkraefte */
      ns = abs(redundanz) * staebe->n; /* Anzahl Stabdicken */
    } else {
    nw = kraefte->m * staebe->n; /* Anzahl innerer Stabkraefte */
    ns = staebe->n; /* Anzahl Stabdicken */
  }
  isred = (unsigned char) 1;
  if (redundanz == 0)
      isred = 0;
  kraefte_norm = (double) 0;
  for(i = 0; i < kraefte->nz; i++)
    kraefte_norm += square(kraefte->ar[i]);
  kraefte_norm = sqrt(kraefte_norm);
  printf("kraefte_norm = %e\n",kraefte_norm);
  *alpha = 1.0/kraefte_norm;
  *beta = 1/smax;
  *gamma = 1/sigma;
  skaliere_berechne_faktoren(alpha,beta,gamma,kraefte_norm,smax,sigma);
  printf("skaliere mit: alpha = %e; beta = %e; gamma = %e\n",*alpha,*beta,*gamma);
  printf("A(>=%d,<%d) : beta * ...\n",2 * nw + isred * staebe->n,nx);
  printf("A(<%d,>=%d) : alpha * gamma * ...\n",2 * nw,nx + nw);
  printf("A(>=%d,>=%d) : beta * gamma * ...\n",2 * nw + isred * ns,nx + nw);
  for(i = 0; i < A->nz; i++)
    if ((A->ia[i] >= 2 * nw + isred * ns) && (A->ja[i] < nx))
      A->ar[i] = *beta * A->ar[i];
    else if ((A->ia[i] < 2 * nw) && (A->ja[i] >= nx + nw))
      A->ar[i] = *alpha * *gamma * A->ar[i];
    else if ((A->ia[i] >= 2 * nw + isred * ns) && (A->ja[i] >= nx + nw))
      A->ar[i] = *beta * *gamma * A->ar[i];
  for(i = 0; i < beq->n; i++)
    beq->val[i] = *alpha * beq->val[i];
  for(i = 0; i < lb->n; i++)
    if ((nx <= i) && (i < nx + nw))
      {
	lb->val[i] = *alpha * lb->val[i];
	ub->val[i] = *alpha * ub->val[i];
      } else if (nx +nw <= i) {
      lb->val[i] = lb->val[i] / *gamma;
      ub->val[i] = ub->val[i] / *gamma;
    }
  for(i = 0; i < z->n; i++)
    z->val[i] = *gamma * z->val[i];
  /* print_double_vektor("lb",lb); */
}

void scale_fn_min_max_sparse_matrix(double *minwert,double *maxwert,struct sparse_matrix *A,double *fs,double *fz,int offset)
{
  int i;
  for(i = 0; i < A->nz; i++)
    { if ((*minwert == 0) || ((fz[offset+A->ia[i]]*fs[A->ja[i]]*fabs(A->ar[i]) > 0) && (fz[offset+A->ia[i]]*fs[A->ja[i]]*fabs(A->ar[i]) < *minwert)))
	*minwert = fz[offset+A->ia[i]]*fs[A->ja[i]]*fabs(A->ar[i]);
      if (*maxwert < fz[offset+A->ia[i]]*fs[A->ja[i]]*fabs(A->ar[i]))
	*maxwert = fz[offset+A->ia[i]]*fs[A->ja[i]]*fabs(A->ar[i]);
    }
}
void scale_fn_min_max_double_vektor(double *minwert,double *maxwert,struct double_vektor *b,double *fs,double *fz,int offset)
{
  int i;
  for(i = 0; i < b->n; i++)
    { if ((*minwert == 0) || ((fz[i]*fabs(b->val[i]) > 0) && (fz[i]*fabs(b->val[i]) < *minwert)))
	*minwert = fz[i]*fabs(b->val[i]);
      if (*maxwert < fz[i]*fabs(b->val[i]))
	*maxwert = fz[i]*fabs(b->val[i]);
    }
}
double scale_fn(double *fs,double *fz,struct sparse_matrix *A,struct double_vektor *b,struct sparse_matrix *Aeq,struct double_vektor *beq,struct double_vektor *lb,struct double_vektor *ub,struct double_vektor *z)
{
  double wert = 0;
  /* double minwert = 0; */
  /* double maxwert = 0; */
  int i,offset;
  /* scale_fn_min_max_sparse_matrix(&minwert,&maxwert,A,fs,fz,0);
     scale_fn_min_max_sparse_matrix(&minwert,&maxwert,Aeq,fs,fz,A->n);
     scale_fn_min_max_double_vektor(&minwert,&maxwert,b,fs,fz,0);
     scale_fn_min_max_double_vektor(&minwert,&maxwert,beq,fs,fz,A->n); */
  /* wert = maxwert/minwert; */
  wert = 0;
  offset = 0;
  for(i = 0; i < A->nz; i++)
    wert += square(fabs(fz[offset+A->ia[i]]*fs[A->ja[i]]*A->ar[i]) - 1.0);
  offset = A->nz;
  for(i = 0; i < Aeq->nz; i++)
    wert += square(fabs(fz[offset+Aeq->ia[i]]*fs[Aeq->ja[i]]*Aeq->ar[i]) - 1.0);

  /* printf("A: min|aij| = %e   max|aij| = %e   ratio = %e\n",minwert,maxwert,wert); */
  return wert;
}
double scale_fn_dummy_ok(double *x,void *info)
{
  struct scale_info *scale_info = (struct scale_info*) info;
  double n = scale_info->n;
  int i;
  double ret;
  for(i = 0; i < scale_info->A->n+scale_info->Aeq->n; i++)
    if (i < min(n/2,scale_info->A->n+scale_info->Aeq->n))
      scale_info->tfz[i] = x[i];
    else
      scale_info->tfz[i] = scale_info->fz[i];
  for(i = 0; i < scale_info->A->m; i++)
    if (i < min(n/2,scale_info->A->m))
      scale_info->tfs[i] = x[min((int)(n/2),scale_info->A->n+scale_info->Aeq->n)+i];
    else
      scale_info->tfs[i] = scale_info->fs[i];
  ret = scale_fn(scale_info->tfs,scale_info->tfz,scale_info->A,scale_info->b,scale_info->Aeq,scale_info->beq,scale_info->lb,scale_info->ub,scale_info->z);
  return ret;
}
double scale_fn_dummy(double *x,void *info)
{
  struct scale_info *scale_info = (struct scale_info*) info;
  double n = scale_info->n;
  int xn1 = min(n/2,scale_info->A->n+scale_info->Aeq->n);
  int xn2 = n-xn1;
  int xn = xn1+xn2;
  int fzn = scale_info->A->n+scale_info->Aeq->n;
  int fsn = scale_info->A->m;
  int fzg = (int) floor((double)fzn / (double)xn1);
  int fsg = (int) floor((double)fsn / (double)xn2);
  int i,j;
  double ret;
  for(i = 0; i <= xn1; i++)
    for(j = 0; j < fzg; j++)
      scale_info->tfz[min(i*fzg+j,fzn-1)] = x[min(i,xn1-1)];
  for(i = 0; i <= xn2; i++)
    for(j = 0; j < fsg; j++)
      scale_info->tfs[min(i*fsg+j,fsn-1)] = x[min(xn1+i,xn-1)];
  ret = scale_fn(scale_info->tfs,scale_info->tfz,scale_info->A,scale_info->b,scale_info->Aeq,scale_info->beq,scale_info->lb,scale_info->ub,scale_info->z);
  return ret;
}
void steilster_abstieg_grad(double *gw,double (*f) (double *x,void *info),double *x,int n,double h,void *info)
{
  /* implizit: x >= eps */
  double eps = 1e-6;
  double *xt1,*xt2;
  int i;
  xt1 = (double*)calloc(n,sizeof(double));assert(xt1 != NULL);
  xt2 = (double*)calloc(n,sizeof(double));assert(xt2 != NULL);
  for(i = 0; i < n; i++) { xt1[i] = x[i]; xt2[i] = x[i];}
  for(i = 0; i < n; i++)
    {
      xt1[i] = x[i] + h; xt2[i] = max(eps,x[i] - h);
      gw[i] = (f(xt1,info)-f(xt2,info))/(2.0*h);
      xt1[i] = x[i]; xt2[i] = x[i];
    }
  free(xt1); free(xt2);
}
void steilster_abstieg(double (*f) (double *x,void *info),double *x,int n,int maxit,double tol,double gradtol,void *info)
{
  /* implizit: x >= eps */
  double eps = 1e-6;
  double fw,ngw;
  int it = 0;
  int itmod = max(1,maxit/10);
  double s0 = 1.0; /* Startschrittweite zur Berechnung der Schrittweite nach Armijo */
  double delta = 0.1; /* Verfahrensparameter zur Berechnung der Schrittweite nach Armijo */
  double beta = 0.9; /* Verfahrensparameter zur Berechnung der Schrittweite nach Armijo */
  double s = s0;
  double dx = 0;
  int i;
  double *xt, *gw;
  xt = (double*)calloc(n,sizeof(double));assert(xt != NULL);
  gw = (double*)calloc(n,sizeof(double));assert(gw != NULL);
  printf("### steilster abstieg (%d Unbekannte)\n",n);
  /* Berechne Funktionswert/Gradienten */
  fw = f(x,info);
  steilster_abstieg_grad(gw,f,x,n,gradtol,info);
  ngw=0;for(i=0;i<n;i++)ngw+=gw[i]*gw[i];ngw=sqrt(ngw);
  printf("it=%d  f(x)=%e  ||grad||=%e\n",it-1,fw,ngw);
  while ((ngw > tol) && (it < maxit))
    {
      /* bestimme Schrittweite nach Armijo */
      s = s0;
      for(i = 0; i < n; i++) xt[i] = max(eps,x[i]-s*gw[i]);
      while (f(xt,info) > fw - delta * s * ngw*ngw)
	{
	  s = s*beta;
	  for(i = 0; i < n; i++) xt[i] = max(eps,x[i]-s*gw[i]);
	}
      /* berechne neuen Punkt */
      dx = 0;
      for(i = 0; i < n; i++) { dx += fabs(s*gw[i]); x[i] = max(eps,x[i]-s*gw[i]); }
      /* Berechne Funktionswert/Gradienten */
      fw = f(x,info);
      steilster_abstieg_grad(gw,f,x,n,gradtol,info);
      ngw=0;for(i=0;i<n;i++)ngw+=gw[i]*gw[i];ngw=sqrt(ngw);
      if (fmod(it,itmod)==0)
	printf("it=%d  f(x)=%e  ||grad||=%e  ||dx||=%e  s=%e\n",it,fw,ngw,sqrt(dx),s);
      it++;
    }
  if (fmod(it-1,itmod)!=0)
    printf("it=%d  f(x)=%e  ||grad||=%e  ||dx||=%e  s=%e\n",it,fw,ngw,sqrt(dx),s);
  free(xt); free(gw);
}
void scale(double *fs,double *fz,struct sparse_matrix *A,struct double_vektor *b,struct sparse_matrix *Aeq,struct double_vektor *beq,struct double_vektor *lb,struct double_vektor *ub,struct double_vektor *z)
{
  double *x;
  int n;
  /* struct scale_info{struct sparse_matrix *A;struct double_vektor *b;struct sparse_matrix *Aeq;struct double_vektor *beq;struct double_vektor *lb;struct double_vektor *ub;struct double_vektor *z;}; */
  struct scale_info scale_info;
  int i,offset;
  int fzn,xn1,xn2,fak;
  double minf;
  printf("################ scale ################ start ################\n");
  fz = (double*)calloc(A->n+Aeq->n,sizeof(double));assert(fz != NULL);
  fs = (double*)calloc(A->m,sizeof(double));assert(fs != NULL);
  scale_info.tfz = (double*)calloc(A->n+Aeq->n,sizeof(double));assert(scale_info.tfz != NULL);
  scale_info.tfs = (double*)calloc(A->m,sizeof(double));assert(scale_info.tfs != NULL);
  for(i = 0; i < A->n+Aeq->n; i++) fz[i] = 1.0; /* Zeilen */
  for(i = 0; i < A->m; i++) fs[i] = 1.0; /* Spalten */
  for(i = 0; i < A->n+Aeq->n; i++) scale_info.tfz[i] = 1.0; /* Zeilen */
  for(i = 0; i < A->m; i++) scale_info.tfs[i] = 1.0; /* Spalten */
  scale_info.A = A; scale_info.b = b; scale_info.Aeq = Aeq; scale_info.beq = beq;
  scale_info.lb = lb; scale_info.ub = ub; scale_info.z = z;
  scale_info.fz = fz; scale_info.fs = fs;
  for(n = 2; n < A->n + A->m; n*=2)
    {
      int fzn,xn1,xn2,fak;
      scale_info.n = n;
      x = (double*)calloc(n,sizeof(double));assert(x != NULL);
      fzn = A->n+Aeq->n;
      xn1 = min((int)(n/2),fzn);
      xn2 = min(n/2,A->m);
      fak = (int) floor((double) fzn / (double) xn1);
      for(i = 0; i < xn1; i++) x[i] = scale_info.tfz[min(i*fak,fzn)]; /* setze startwert */
      fak = (int) floor((double) A->m / (double) xn2);
      for(i = 0; i < xn2; i++) x[xn1+i] = scale_info.tfs[min(i*fak,A->m)]; /* setze startwert */
      steilster_abstieg(&scale_fn_dummy,x,n,10,1e-6,1e-14,&scale_info);
      for(i = 0; i < xn1; i++) fz[i] = scale_info.tfz[i];
      for(i = 0; i < xn2; i++) fs[i] = scale_info.tfs[i];
      free(x);
    }
  n = A->n+Aeq->n + A->m; scale_info.n = n;
  x = (double*)calloc(n,sizeof(double));assert(x != NULL);
  fzn = A->n+Aeq->n;
  xn1 = min((int)(n/2),fzn);
  xn2 = min(n/2,A->m);
  fak = (int) floor((double) fzn / (double) xn1);
  for(i = 0; i < xn1; i++) x[i] = scale_info.tfz[min(i*fak,fzn)]; /* setze startwert */
  fak = (int) floor((double) A->m / (double) xn2);
  for(i = 0; i < xn2; i++) x[xn1+i] = scale_info.tfs[min(i*fak,A->m)]; /* setze startwert */
  steilster_abstieg(&scale_fn_dummy,x,n,10,1e-6,1e-14,&scale_info);
  for(i = 0; i < xn1; i++) fz[i] = scale_info.tfz[i];
  for(i = 0; i < xn2; i++) fs[i] = scale_info.tfs[i];
  free(x);
  free(scale_info.tfz);
  free(scale_info.tfs);
  offset = 0;
  for(i = 0; i < A->nz; i++)
    A->ar[i] *= fz[offset+A->ia[i]]*fs[A->ja[i]];
  offset = A->nz;
  for(i = 0; i < Aeq->nz; i++)
    Aeq->ar[i] *= fz[offset+Aeq->ia[i]]*fs[Aeq->ja[i]];
  minf = 0;
  for(i = 0; i < A->nz; i++)
    if (fz[A->ia[i]] < minf) minf = fz[A->ia[i]];
  printf("minf = %e\n",minf);
  printf("################ scale ################ ende ################\n");
}
