/*
TrussTopologyRobustRedundant - structs

Author: Daniel Mohr
Date: 2012-02-26
*/

#include "ttrr_structs.h"

void definiere_sparse_matrix(struct sparse_matrix *A)
{ /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
  A->ia = (int*)calloc(A->nz,sizeof(int));assert(A->ia != NULL);
  A->ja = (int*)calloc(A->nz,sizeof(int));assert(A->ja != NULL);
  A->ar = (double*)calloc(A->nz,sizeof(double));assert(A->ar != NULL);
}
void initialisiere_wert_sparse_matrix(struct sparse_matrix *A,const int i,const struct sparse_matrix *B,const int j)
{ /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
  A->ia[i] = B->ia[j];
  A->ja[i] = B->ja[j];
  A->ar[i] = B->ar[j];
}
void sparse_matrix_zeilenreduktion(struct sparse_matrix *A,const struct int_vektor *zeilen)
{
  struct sparse_matrix H;
  int indexshift=0;
  int i=0,j=0;
  H.nz = A->nz;
  definiere_sparse_matrix(&H);
  H.i = 0;
  for(i = 0; i < A->n; i++)
    {
      unsigned char kommtvor = 0;
      for(j = 0; j < zeilen->n; j++)
	if (i == zeilen->val[j])
	  { kommtvor = 1; j = zeilen->n; }
      if (kommtvor == 1)
	{
	  for(j = 0; j < A->nz; j++)
	    if (i == A->ia[j])
	      {
		initialisiere_wert_sparse_matrix(&H,H.i,A,j);
		H.ia[H.i] = H.ia[H.i] - indexshift;
		H.i++;
		A->ia[j] = -1;
	      }
	} else {
	/* passe Indizes an */
	for(j = 0; j < A->nz; j++)
	  if (i == A->ia[j])
	    A->ia[j] = -1;
	indexshift++;
      }
    }
  free(A->ia);
  free(A->ja);
  free(A->ar);
  A->nz = H.i;
  A->n = zeilen->n;
  definiere_sparse_matrix(A);
  for(i = 0; i < A->nz; i++)
    initialisiere_wert_sparse_matrix(A,i,&H,i);
  free(H.ia);
  free(H.ja);
  free(H.ar);
}
void initialisiere_null_double_matrix(struct double_matrix *A)
{ /* struct double_matrix{int n,m;double **val;}; */
  A->n = (int) 0;
  A->m = (int) 0;
  A->val = NULL;
}
void initialisiere_null_int_matrix(struct int_matrix *A)
{ /* struct double_matrix{int n,m;int **val;}; */
  A->n = (int) 0;
  A->m = (int) 0;
  A->val = NULL;
}
void initialisiere_null_int_vektor(struct int_vektor *x)
{ /* int_vektor{int i,n;int *val;}; */
  x->i = (int) 0;
  x->n = (int) 0;
  x->val = NULL;
}
void initialisiere_null_double_vektor(struct double_vektor *x)
{ /* int_double{int i,n;double *val;}; */
  x->i = (int) 0;
  x->n = (int) 0;
  x->val = NULL;
}
void initialisiere_null_sparse_matrix(struct sparse_matrix *A)
{ /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
  A->i = (int) 0;
  A->n = (int) 0;
  A->m = (int) 0;
  A->nz = (int) 0;
  A->ia = NULL;
  A->ja = NULL;
  A->ar = NULL;
}
