/*
TrussTopologyRobustRedundant - tools

Author: Daniel Mohr
Date: 2012-02-27
*/

#include "ttrr_tools.h"

void berechne_abstaende(long double *dx,long double *dy,long double *dz,int a,int b,const struct double_matrix *knoten,const struct int_matrix *staebe)
{
  long double ax,ay,az,bx,by,bz;
  *dz = 0;
  ax = knoten->val[a][0];
  ay = knoten->val[a][1];
  bx = knoten->val[b][0];
  by = knoten->val[b][1];
  *dx = ax-bx;
  *dy = ay-by;
  if (knoten->m > 2)
    {
      az = knoten->val[a][2];
      bz = knoten->val[b][2];
      *dz=az-bz;
    }
}

void print_int_vektor(const char *name,struct int_vektor *vektor)
{
  int i;
  /* struct int_vektor{int i,n;int *val;}; */
  printf("%s:",name);
  for(i = 0; i < vektor->n; i++)
    printf(" %i",vektor->val[i]);
  printf("\n");
}

void print_double_vektor(const char *name,struct double_vektor *vektor)
{
  int i;
  /* struct int_vektor{int i,n;int *val;}; */
  printf("%s:",name);
  for(i = 0; i < vektor->n; i++)
    printf(" %1.2e",vektor->val[i]);
  printf("\n");
}

void print_sparse_matrix(const char *name,struct sparse_matrix *A)
{
  int i;
  /* struct sparse_matrix{int i,n,m,nz,*ia,*ja;double *ar;}; */
  printf("%s:",name);
  for(i = 0; i < A->nz; i++)
    printf(" (%i,%i)=%e",A->ia[i],A->ja[i],A->ar[i]);
  printf("\n");
}

void hole_mip_solution(struct double_vektor *solution,struct int_vektor *x,struct double_vektor *w,struct double_vektor *s,glp_prob *lpmip)
{
  int i;
  for(i = 0; i < solution->n; i++)
    {
      solution->val[i] = glp_mip_col_val(lpmip,i+1);
      if (i < x->n)
	x->val[i] = solution->val[i];
      else if ((x->n <= i) && (i < x->n + w->n))
	  w->val[i - x->n] = solution->val[i];
      else if (x->n + w->n <= i)
	s->val[i - x->n - w->n] = solution->val[i];
    }
}
