#!/usr/bin/python -BO
#!/usr/bin/python -O
import ttrr as top
dim = 3 # Raumdimension
nelx = 3
nely = nelx
nelz = nelx
# Definition des Gitters
gx0 = 0.0 # Meter
gx1 = 1.0 # Meter
gy0 = 0.0 # Meter
gy1 = 1.0 # Meter
gz0 = 0.0 # Meter
gz1 = 1.0 # Meter
##################################################
# Lager: alle Knoten auf der linken Seite
lager = top.numpy.arange(0,dim*nely*nelz,dtype=top.numpy.uint16)
(ln,) = lager.shape
##################################################
[knoten,staebe]=top.staebeknotenaufgitter3d(gx0,gx1,gy0,gy1,gz0,gz1,nelx,nely,nelz,lager)
(kn,kr) = knoten.shape
(sn,sr) = staebe.shape
##################################################
print('%d Knoten und %d Staebe.' % (kn,sn))
ls = ''
for i in range(0,ln):
    ls = '%s %d' % (ls,lager[i])
print('gelagerte Knoten-Richtungen: %s' % (ls))
##################################################
# 1 Lastfall; unten rechts nach unten
kraefte = top.scipy.sparse.lil_matrix((dim*kn,1),dtype=top.numpy.float64)
if top.iseven(nely):
    k = nelx*nely*(nelz-1)+nely/2
else:
    k = nelx*nely*(nelz-1)+(nely+1)/2-1
r = dim*k
kraefte[r,0] = -100000.0 # Newton = ca. 1000 kg
print('Kraft im Knoten %d auf der Richtung %d (Lastfall 1)' % (k,r))
smax=0.01 # Meter^2
name="kran%sx%sx%s_lastfall1" % (nelx,nely,nelz)
[s,w,laengen] = top.ttrr(dim,knoten,staebe,lager,kraefte,smax,name=name,redundanz=0,opt=0)
