import numpy
_epsilon = numpy.sqrt(numpy.finfo(float).eps)
def knotennummervonkoordinaten(knoten,x,y,z=0,eps=_epsilon):
    """kk = knotennummervonkoordinaten(knoten,x,y,z=0,eps=_epsilon)
    calculates the number of a node from the coordinates.

    knoten   is a matrix to represent all nodal points with
             knoten(k,:) are the nodal points
             knoten(:,1) are the x-coordinates of the nodal points
             knoten(:,2) are the y-coordinates of the nodal points
             knoten(:,3) are the z-coordinates of the nodal points (optional)
    x,y,z    gives the coordinate of the wanted node.
             If the dimension of the design space (it is get from the dimension
             of knoten) is 2 z is ignored. z is optional.
    eps      is a bound for the possible difference between the coordinate of
             the wanted node and given coordinate.

    Author: Daniel Mohr
    Date: 2012-01-23, 2012-01-28 (last change)
    License: GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007

    Copyright (C) 2012 Daniel Mohr
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 3 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, see
    http://www.gnu.org/licenses/"""
    kk = -1
    (kn,dim) = knoten.shape
    #if dim == 2:
    #    print('bestimme Knotennummer fuer (%f,%f) mit einer Genauigkeit von %e' % (x,y,eps))
    #if dim == 3:
    #    print('bestimme Knotennummer fuer (%f,%f,%f) mit einer Genauigkeit von %e' % (x,y,z,eps))
    for k in range(0,kn):
        if dim == 2:
            if (((x-eps <= knoten[k,0]) and
                 (knoten[k,0] <= x+eps)) and
                ((y-eps <= knoten[k,1]) and
                 (knoten[k,1] <= y+eps))):
                kk = k
        if dim == 3:
            if (((x-eps <= knoten[k,0]) and
                 (knoten[k,0] <= x+eps)) and
                ((y-eps <= knoten[k,1]) and
                 (knoten[k,1] <= y+eps) and
                ((z-eps <= knoten[k,2]) and
                 (knoten[k,2] <= z+eps)))):
                kk = k
    return kk
