import os,tarfile,sys,tempfile
from .ttrr_read import *

def create_png_pdf_gnuplot_simple(file,smin,smax,xaufloesung,yaufloesung,neu,gnuplot_pdf,gnuplot_png,args):
    """Author: Daniel Mohr
    Date: 2012-03-07 (last change)
    License: GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007"""
    from .ttrr_visualisation import farben,skaliere,skalieremultiplikativ,skalierelinear
    dd = os.path.splitext(file)[0]
    dd = os.path.splitext(dd)[0]
    if args.all_bars:
        dd += '_all_bars'
    ddgnu = '%s.gnu' % (dd)
    ddpdf = '%s.pdf' % (dd)
    ddpng = '%s.png' % (dd)
    if (((gnuplot_png and (neu==False or os.path.isfile(ddpng)==False)) or
          (gnuplot_pdf and (neu==False or os.path.isfile(ddpdf)==False))) and
         os.path.isfile(file) and tarfile.is_tarfile(file)):
        tar = tarfile.open(file,'r:bz2')
        tar_names = tar.getnames();
        if ((("s.bin" in tar_names) or (("s.txt" in tar_names))) and
            (("staebe.bin" in tar_names) or (("staebe.txt" in tar_names))) and
            (("knoten.bin" in tar_names) or (("knoten.txt" in tar_names))) and
            (("kraefte.bin" in tar_names) or (("kraefte.txt" in tar_names))) and
            (("lager.bin" in tar_names) or (("lager.txt" in tar_names))) and
            (("redundanz.bin" in tar_names) or (("redundanz.txt" in tar_names))) and
            (("dim.bin" in tar_names) or (("dim.txt" in tar_names)))):
            if gnuplot_pdf and gnuplot_png:
                print('create png and pdf with gnuplot for "%s"' % file)
            elif gnuplot_pdf and gnuplot_png==False:
                print('create pdf with gnuplot for "%s"' % file)
            elif gnuplot_pdf==False and gnuplot_png:
                print('create png with gnuplot for "%s"' % file)
            sys.stdout.flush()
            s = lese_double_vektor_tar(tar,tar_names,"s")
            if args.all_bars:
                for i in range(0,len(s)):
                    s[i] = 1
            staebe = lese_int_matrix_tar(tar,tar_names,"staebe")
            sn = len(staebe)
            knoten = lese_double_matrix_tar(tar,tar_names,"knoten")
            kraefte = lese_sparsematrix_tar(tar,tar_names,"kraefte")
            lager = lese_int_vektor_tar(tar,tar_names,"lager")
            dim = lese_int_tar(tar,tar_names,"dim")
            redundanz = abs(lese_int_tar(tar,tar_names,"redundanz"))
            if redundanz == 0:
                redundanz = 1
            tmpfile = tempfile.NamedTemporaryFile(prefix='ttrr_tmp_',delete=False)
            tmpfile.close()
            fdtmp = open(tmpfile.name,'w') # gnuplot ausgabe
            fd = open(ddgnu,'w') # gnuplot ausgabe
            fd.write('# %s\n' % dd)
            fd.write('# set terminal pdf enhanced color size 10cm,10cm\n')
            fd.write('# set output "%s"\n' % ddpdf)
            fd.write('# set terminal png transparent nointerlace font "/usr/share/texmf-dist/fonts/truetype/public/gnu-freefont/FreeSans.ttf,30" enhanced size %d,%d nocrop\n' % (xaufloesung,yaufloesung))
            fd.write('# set output "%s"\n' % ddpng)
            if gnuplot_pdf:
                fdtmp.write('set terminal pdf enhanced color size 10cm,10cm\n')
                fdtmp.write('set output "%s"\n' % ddpdf)
                fdtmp.write('load "%s"\n' % ddgnu)
            if gnuplot_png:
                fdtmp.write('set terminal png nointerlace font "/usr/share/texmf-dist/fonts/truetype/public/gnu-freefont/FreeSans.ttf,30" enhanced size %d,%d nocrop\n' % (xaufloesung,yaufloesung))
                fdtmp.write('set output "%s"\n' % ddpng)
                fdtmp.write('load "%s"\n' % ddgnu)
            # zeichne
            j = 0
            fd.write('unset arrow\n')
            fd.write('set xrange [%2.1f:%2.1f]\n' % (numpy.amin(knoten),numpy.amax(knoten)))
            fd.write('set yrange [%2.1f:%2.1f]\n' % (numpy.amin(knoten),numpy.amax(knoten)))
            if dim == 3:
                fd.write('set zrange [%2.1f:%2.1f]\n' % (numpy.amin(knoten),numpy.amax(knoten)))
            for r in range(0,redundanz):
                if redundanz > 1:
                    fd.write('# Struktur %d\n' % (r+1))
                    ff = open("%s_x%d.gnu" % (dd,r+1),'w')
                    ff.write('# %s\n' % dd)
                    ff.write('# Struktur %d\n' % (r+1))
                    ff.write('# set terminal pdf enhanced color size 10cm,10cm\n')
                    ff.write('# set output "%s_x%d.pdf"\n' % (dd,r+1))
                    ff.write('# set terminal png transparent nointerlace font "/usr/share/texmf-dist/fonts/truetype/public/gnu-freefont/FreeSans.ttf,30" enhanced size %d,%d nocrop\n' % (xaufloesung,yaufloesung))
                    ff.write('# set output "%s_x%d.png"\n' % (dd,r+1))
                    fdtmp.write('set terminal pdf enhanced color size 10cm,10cm\n')
                    fdtmp.write('set output "%s_x%d.pdf"\n' % (dd,r+1))
                    fdtmp.write('load "%s_x%d.gnu"\n' % (dd,r+1))
                    fdtmp.write('set terminal png nointerlace font "/usr/share/texmf-dist/fonts/truetype/public/gnu-freefont/FreeSans.ttf,30" enhanced size %d,%d nocrop\n' % (xaufloesung,yaufloesung))
                    fdtmp.write('set output "%s_x%d.png"\n' % (dd,r+1))
                    fdtmp.write('load "%s_x%d.gnu"\n' % (dd,r+1))
                    ff.write('unset arrow\n')
                    ff.write('set xrange [%2.1f:%2.1f]\n' % (numpy.amin(knoten),numpy.amax(knoten)))
                    ff.write('set yrange [%2.1f:%2.1f]\n' % (numpy.amin(knoten),numpy.amax(knoten)))
                for i in range(0,sn):
                    if s[r*sn+i] >= smin:
                        if dim == 2:
                            fd.write('set arrow %i from %2.1f,%2.1f to %2.1f,%2.1f nohead lt rgb "%s" lw %2.1f\n' % (j+1,knoten[staebe[i,0],0],knoten[staebe[i,0],1],knoten[staebe[i,1],0],knoten[staebe[i,1],1],farben(r,1),skaliere(s[r*sn+i],smin,smax)))
                            if redundanz > 1:
                                ff.write('set arrow %i from %2.1f,%2.1f to %2.1f,%2.1f nohead lt rgb "%s" lw %2.1f\n' % (j+1,knoten[staebe[i,0],0],knoten[staebe[i,0],1],knoten[staebe[i,1],0],knoten[staebe[i,1],1],farben(r,1),skaliere(s[r*sn+i],smin,smax)))
                        if dim == 3:
                            fd.write('set arrow %i from %2.1f,%2.1f,%2.1f to %2.1f,%2.1f,%2.1f nohead lt rgb "%s" lw %2.1f\n' % (j+1,knoten[staebe[i,0],0],knoten[staebe[i,0],1],knoten[staebe[i,0],2],knoten[staebe[i,1],0],knoten[staebe[i,1],1],knoten[staebe[i,1],2],farben(r,1),skaliere(s[r*sn+i],smin,smax)))
                            if redundanz > 1:
                                ff.write('set arrow %i from %2.1f,%2.1f,%2.1f to %2.1f,%2.1f,%2.1f nohead lt rgb "%s" lw %2.1f\n' % (j+1,knoten[staebe[i,0],0],knoten[staebe[i,0],1],knoten[staebe[i,0],2],knoten[staebe[i,1],0],knoten[staebe[i,1],1],knoten[staebe[i,1],2],farben(r,1),skaliere(s[r*sn+i],smin,smax)))
                        j = j + 1
                if redundanz > 1:
                    if dim == 2:
                        ff.write('set ticslevel 0\nset view equal xyz\n')
                        ff.write('plot 0 ls -1 notitle\n')
                    if dim == 3:
                        ff.write('set ticslevel 0\nset view equal xyz\n')
                        ff.write('splot 0 ls -1 notitle\n')
                    os.fsync(ff)
                    ff.close()
            if dim == 2:
                fd.write('set ticslevel 0\nset view equal xyz\n')
                fd.write('plot 0 ls -1 notitle\n')
            if dim == 3:
                fd.write('set ticslevel 0\nset view equal xyz\n')
                fd.write('splot 0 ls -1 notitle\n')
            os.fsync(fd)
            fd.close()
            os.fsync(fdtmp)
            fdtmp.close()
            prg = 'gnuplot %s' % (tmpfile.name)
            os.system(prg)
            os.unlink(tmpfile.name)
        tar.close()
    else:
        print('"%s" is no tar-file or pictures/movies exists' % file)
        if gnuplot_png and neu and os.path.isfile(ddpng):
            print('  picture "%s" already exists' % ddpng)
        if gnuplot_pdf and neu and os.path.isfile(ddpdf):
            print('  picture "%s" already exists' % ddpdf)
        if os.path.isfile(file) == False:
            print('  "%s" is no file' % file)
        if os.path.isfile(file) and (tarfile.is_tarfile(file)==False):
            print('  "%s" is no tar-file' % file)
        sys.stdout.flush()
    return
