import os,sys,struct,array,numpy,string,scipy.sparse

def lese_int_vektor(pathname,filename):
    f = "%s/%s.bin" % (pathname,filename)
    if os.path.isfile(f):
        fd = open(f,'rb')
        n = struct.unpack('<i',fd.read(struct.calcsize('<i')))[0]
        b = array.array('i')
        for i in range(0,n):
            b.append(struct.unpack('<i',fd.read(struct.calcsize('<i')))[0])
        fd.close()
    else:
        f = "%s/%s.txt" % (pathname,filename)
        fd = open(f,'r')
        n = int(fd.readline())
        b = array.array('i')
        for i in range(0,n):
            b.append(int(fd.readline()))
        fd.close()
    return b
def lese_double_vektor(pathname,filename):
    f = "%s/%s.bin" % (pathname,filename)
    if os.path.isfile(f):
        fd = open(f,'rb')
        n = struct.unpack('<i',fd.read(struct.calcsize('<i')))[0]
        b = array.array('d')
        for i in range(0,n):
            b.append(struct.unpack('<d',fd.read(struct.calcsize('<d')))[0])
        fd.close()
    else:
        f = "%s/%s.txt" % (pathname,filename)
        fd = open(f,'r')
        n = int(fd.readline())
        b = array.array('d')
        for i in range(0,n):
            b.append(float(fd.readline()))
        fd.close()
    return b
def lese_double_vektor_bin(fd):
    n = struct.unpack('<i',fd.read(struct.calcsize('<i')))[0]
    b = array.array('d')
    for i in range(0,n):
        b.append(struct.unpack('<d',fd.read(struct.calcsize('<d')))[0])
    return b
def lese_int_vektor_bin(fd):
    n = struct.unpack('<i',fd.read(struct.calcsize('<i')))[0]
    b = array.array('i')
    for i in range(0,n):
        b.append(struct.unpack('<i',fd.read(struct.calcsize('<i')))[0])
    return b
def lese_double_vektor_txt(fd):
    n = int(fd.readline())
    b = array.array('d')
    for i in range(0,n):
        b.append(float(fd.readline()))
    return b
def lese_int_vektor_txt(fd):
    n = int(fd.readline())
    b = array.array('i')
    for i in range(0,n):
        b.append(int(fd.readline()))
    return b
def lese_double_vektor_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        s = lese_double_vektor_bin(fd)
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        s = lese_double_vektor_txt(fd)
        fd.close()
    return s
def lese_int_vektor_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        s = lese_int_vektor_bin(fd)
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        s = lese_int_vektor_txt(fd)
        fd.close()
    return s
def lese_int_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        s = struct.unpack('<i',fd.read(struct.calcsize('<i')))[0]
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        s = int(fd.readline())
        fd.close()
    return s
def lese_double_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        s = struct.unpack('<d',fd.read(struct.calcsize('<d')))[0]
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        s = float(fd.readline())
        fd.close()
    return s
def lese_double_matrix_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        [n,m] = struct.unpack('<ii',fd.read(struct.calcsize('<ii')))
        A = numpy.zeros((n,m),dtype=numpy.double)
        for i in range(0,n):
            for j in range(0,m):
                A[i,j] = struct.unpack('<d',fd.read(struct.calcsize('<d')))[0]
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        zeile = fd.readline()
        [n,m] = string.split(zeile,' ')
        n = int(n)
        m = int(m)
        A = numpy.zeros((n,m),dtype=numpy.double)
        for i in range(0,n):
            zeile = fd.readline()
            zs = string.split(zeile,' ')
            for j in range(0,m):
                A[i,j] = float(zs[j])
        fd.close()
    return A
def lese_int_matrix_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        [n,m] = struct.unpack('<ii',fd.read(struct.calcsize('<ii')))
        A = numpy.zeros((n,m),dtype=numpy.int)
        for i in range(0,n):
            for j in range(0,m):
                A[i,j] = struct.unpack('<i',fd.read(struct.calcsize('<i')))[0]
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        zeile = fd.readline()
        [n,m] = string.split(zeile,' ')
        n = int(n)
        m = int(m)
        A = numpy.zeros((n,m),dtype=numpy.int)
        for i in range(0,n):
            zeile = fd.readline()
            zs = string.split(zeile,' ')
            for j in range(0,m):
                A[i,j] = int(zs[j])
        fd.close()
    return A
def lese_int_matrix_parameter_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        [n,m] = struct.unpack('<ii',fd.read(struct.calcsize('<ii')))
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        zeile = fd.readline()
        [n,m] = string.split(zeile,' ')
        n = int(n)
        m = int(m)
        fd.close()
    return [n,m]
def lese_sparsematrix_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        [n,m,nz] = struct.unpack('<iii',fd.read(struct.calcsize('<iii')))
        A = scipy.sparse.lil_matrix((n,m),dtype=numpy.double)
        ia = array.array('i')
        ja = array.array('i')
        ar = array.array('d')
        for i in range(0,nz):
            ia.append(struct.unpack('<i',fd.read(struct.calcsize('<i')))[0])
        for i in range(0,nz):
            ja.append(struct.unpack('<i',fd.read(struct.calcsize('<i')))[0])
        for i in range(0,nz):
            ar.append(struct.unpack('<d',fd.read(struct.calcsize('<d')))[0])
        for i in range(0,nz):
            A[ia[i],ja[i]] = ar[i]
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        zeile = fd.readline()
        [n,m,nz] = string.split(zeile,' ')
        n = int(n)
        m = int(m)
        nz = int(nz)
        A = scipy.sparse.lil_matrix((n,m),dtype=numpy.double)
        for i in range(0,nz):
            zeile = fd.readline()
            [ai,aj,ar] = string.split(zeile,' ')
            A[int(ai),int(aj)] = float(ar)
        fd.close()
    return A
def lese_sparsematrix_parameter_tar(tar,tar_names,filename):
    if '%s.bin' % filename in tar_names:
        fd = tar.extractfile('%s.bin' % filename)
        [n,m,nz] = struct.unpack('<iii',fd.read(struct.calcsize('<iii')))
        fd.close()
    else:
        fd = tar.extractfile('%s.txt' % filename)
        zeile = fd.readline()
        [n,m,nz] = string.split(zeile,' ')
        n = int(n)
        m = int(m)
        nz = int(nz)
        fd.close()
    return [n,m,nz]
