import tarfile,math
from .ttrr_read import *
import numpy,scipy
import numpy.linalg

def hole_result(tar,v=0):
    tar_names = tar.getnames();
    red = -1
    sn = -1
    dim = -1
    redundanz = 0
    nl = -1
    if (("redundanz.bin" in tar_names) or ("redundanz.txt" in tar_names)):
        redundanz = lese_int_tar(tar,tar_names,"redundanz")
        red = abs(redundanz)
        if red == 0:
            red = 1
        str_redundanz = '% 10d' % redundanz
    else:
        str_redundanz = ''.center(10)
    if (("staebe.bin" in tar_names) or ("staebe.txt" in tar_names)):
        [sn,dim] = lese_int_matrix_parameter_tar(tar,tar_names,'staebe')
    if (("zielfktwert.bin" in tar_names) or ("zielfktwert.txt" in tar_names)):
        zielfunktionswert = lese_double_tar(tar,tar_names,"zielfktwert")
        str_zielfunktionswert = '% 14.8e' % zielfunktionswert
    elif ((("s.bin" in tar_names) or ("s.txt" in tar_names)) and
          (("laengen.bin" in tar_names) or ("laengen.txt" in tar_names))):
        s = numpy.asarray(lese_double_vektor_tar(tar,tar_names,"s"))
        laengen = numpy.asarray(lese_double_vektor_tar(tar,tar_names,"laengen"))
        zielfunktionswert = 0
        for i in range(0,max(red,1)):
            zielfunktionswert += numpy.vdot(s[i*sn:(1+i)*sn],laengen)
        str_zielfunktionswert = '% 14.8e' % zielfunktionswert
    else:
        str_zielfunktionswert = ''.center(15)
    if (("kraefte.bin" in tar_names) or ("kraefte.txt" in tar_names)):
        [nN,nl,nz] = lese_sparsematrix_parameter_tar(tar,tar_names,"kraefte")
        str_nl = '% 4d' % nl
    else:
        str_nl = ''.center(4)
    if sn == -1:
        str_sn = ''.center(6)
    else:
        str_sn = '% 6d' % sn
    if v>0:
        # lese weitere daten
        name = ''
        A = scipy.sparse.lil_matrix((1,1),dtype=numpy.double)
        Aeq = scipy.sparse.lil_matrix((1,1),dtype=numpy.double)
        s = 0
        if ("info.txt" in tar_names):
            fd = tar.extractfile('info.txt')
            name = fd.readline()
            fd.close()
        if ("A.bin" in tar_names) or ("A.txt" in tar_names):
            A = lese_sparsematrix_tar(tar,tar_names,"A")
        if ("Aeq.bin" in tar_names) or ("Aeq.txt" in tar_names):
            Aeq = lese_sparsematrix_tar(tar,tar_names,"Aeq")
        if ("s.bin" in tar_names) or ("s.txt" in tar_names):
            s = numpy.asarray(lese_double_vektor_tar(tar,tar_names,"s"))
    if v==0:
        ret = [red,sn,dim,str_zielfunktionswert,str_redundanz,str_sn,str_nl,redundanz,sn,nl]
    elif v==1:
        ret = [red,sn,dim,str_zielfunktionswert,str_redundanz,str_sn,str_nl,redundanz,sn,nl,
               name,A,Aeq,s]
    return ret

def my_linear(x):
    return x
def my_log(x):
    return math.frexp(x)[1]
def histogram_asciiart(s,smin,smax,w,h=3,histn=100):
    if w == 'log':
        myfunc = my_log
    else:
        myfunc = my_linear
    hist = range(histn)
    histbin = (smax-smin)/histn
    histbins = range(histn)
    m = 0
    for i in range(histn):
        hist[i] = 0
        histbins[i] = smin+i*histbin
        for bar in s:
            if (smin+i*histbin <= bar) and (bar < smin+(i+1)*histbin):
                hist[i] += 1
            if (i == histn-1) and (smin+i*histbin <= bar) and (bar == smin+(i+1)*histbin):
                hist[i] += 1
        if m < hist[i]:
            m = hist[i]
    o = []
    for i in range(h):
        o.append('')
    m = myfunc(m)
    z = ''
    for i in range(histn):
        z += '-'
        for j in range(h):
            if myfunc(hist[i]) > (h-(j+1))*m/h:
                o[j] += "#"
            else:
                o[j] += " "
    ret = '+%s+\n' % z
    for j in range(h):
        ret += '|'
        ret += o[j]
        ret += '|\n'
    ret += '+%s+' % z
    return ret

def histogram_numbers(s,smin,smax,histn):
    hist = range(histn)
    histbin = (smax-smin)/histn
    histbins = range(histn)
    output1 = ''
    output12 = ''
    output2 = ''
    output22 = ''
    output3 = ''
    for i in range(histn):
        hist[i] = 0
        histbins[i] = smin+i*histbin
        for bar in s:
            if (smin+i*histbin <= bar) and (bar < smin+(i+1)*histbin):
                hist[i] += 1
            if (i == histn-1) and (smin+i*histbin <= bar) and (bar == smin+(i+1)*histbin):
                hist[i] += 1
        output1 += '% 2.2e' % (histbins[i])
        output12 += '% 2.2e' % (histbins[i]+histbin)
        output2 += '% 2.6f' % (histbins[i])
        output22 += '% 2.6f' % (histbins[i]+histbin)
        output3 += '% 9d' % (hist[i])
    ret = 'hist.bins: %s\n' % output1
    ret += 'hist.bins: %s' % output12
    ret += 'hist.:     %s' % output3
    return ret

def show_result_of_a_file(filename,args):
    if numpy.isscalar(args.minfaktor):
        args.minfaktor = args.minfaktor
    else:
        args.minfaktor = args.minfaktor[0]
    if os.path.isfile(filename) and tarfile.is_tarfile(filename):
        tar = tarfile.open(filename,'r:bz2')
        [red,sn,dim,str_zielfunktionswert,str_redundanz,str_sn,str_nl,redundanz,sn,nl,name,A,Aeq,s] = hole_result(tar,1)
        print('### %s: %s ###' % (filename,name))
        print('redundancy: %d   #bars: %d   #load cases: %d   #values: %d   #mip.-val.: %d   #equations: %d   #inequations: %d' % (redundanz,sn,nl,(abs(redundanz)*sn+red*sn*nl+red*sn),(abs(redundanz)*sn),Aeq.shape[0],A.shape[0]))
        print('opt.ovj.val.: %s' % str_zielfunktionswert)
        if numpy.isscalar(s)==False:
            smax=numpy.amax(s)
            smin=numpy.amin(s)
            smin2 = smax
            for bar in s:
                if (bar > 0) and (bar < smin2):
                    smin2 = bar
            smin3 = smax
            for bar in s:
                if (bar > args.minfaktor*smax) and (bar < smin3):
                    smin3 = bar
            print('minfaktor*smax: %e' % (args.minfaktor*smax))
            print('bars: %e <= 0 <= %e <= %e <= %e' % (smin,smin2,smin3,smax))
            if args.hist == 'numbers' or args.hist == 'all':
                print(histogram_numbers(s,smin,smax,12))
            if args.hist == 'asciiart' or args.hist == 'all':
                print(histogram_asciiart(s,smin,smax,'linear',args.ascii_hist_l,args.ascii_hist_c))
            if args.hist == 'log_asciiart' or args.hist == 'all':
                print(histogram_asciiart(s,smin,smax,'log',args.ascii_hist_l,args.ascii_hist_c))
        tar.close()
    return

def show_results(args):
    if not numpy.isscalar(args.ascii_hist_c):
        args.ascii_hist_c = args.ascii_hist_c[0]
    if not numpy.isscalar(args.ascii_hist_l):
        args.ascii_hist_l = args.ascii_hist_l[0]
    if args.show_results:
        for filename in args.file:
            show_result_of_a_file(filename,args)
    return

def show_result_table(args):
    if args.show_result_table:
        spaltenbreite = max(map(len,args.file))
        print('#%s %s %s %s %s %s %s' % ('file'.center(spaltenbreite-1),'opt.obj.val.'.center(15),'redundancy'.center(10),'N'.center(6),'nl'.center(4),'values'.center(8),'mip.val.'.center(8)))
        for filename in args.file:
            if os.path.isfile(filename) and tarfile.is_tarfile(filename):
                tar = tarfile.open(filename,'r:bz2')
                [red,sn,dim,str_zielfunktionswert,str_redundanz,str_sn,str_nl,redundanz,sn,nl] = hole_result(tar)
                print('%s %s %s %s %s % 8d % 8d' % (filename.ljust(spaltenbreite),str_zielfunktionswert,str_redundanz,str_sn,str_nl,(abs(redundanz)*sn+red*sn*nl+red*sn),(abs(redundanz)*sn)))
                tar.close()
        
    return
