import numpy,tarfile,os,sys
_epsilon = numpy.sqrt(numpy.finfo(float).eps)

def speichere_problem(name,tmpdir):
    print('speichere nach %s.tar.bz2' % name)
    tar = tarfile.open('%s.tar.bz2' % name,'w:bz2')
    for d in os.listdir(tmpdir):
        tar.add('%s/%s' % (tmpdir,d),arcname=d)
    tar.close()
    return
def lasse_problem_loesen(tmpdir):
    print('### --- ### --- ### --- ### --- ### --- ### --- ###')
    programm = 'ttrr_calculate %s ' % (tmpdir)
    print('starte: %s' % programm)
    sys.stdout.flush()
    os.system(programm)
    sys.stdout.flush()
    print('### --- ### --- ### --- ### --- ### --- ### --- ###')
    return
def ggT(z,n):
    """ggt=ggT(z,n)
    
    Der groesste gemeinsame Teiler ggT von z und n wird mittels Euklid'schen Algorithmus bestimmt.
    
    Autor: Daniel Mohr
    Datum: 2009-10-16 (letzte Aenderung)
    Lizenz: GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007"""
    z = abs(z)
    n = abs(n)
    while (n != 0):
        tmp = n
        n = z - numpy.floor(z/n) * n
        z = tmp
    return z
def iseven(x):
    """iseven(x)

    gibt True zurueck, wenn x gerade ist.
    gibt False zureck, wenn x ungerade ist.
    Autor: Daniel Mohr
    Datum: 2012-02-20 (letzte Aenderung)
    Lizenz: GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007"""
    if numpy.floor(x/2.0) == 0:
        ret = True
    else:
        ret = False
    return ret
def isodd(x):
    """isodd(x)

    gibt True zurueck, wenn x ungerade ist.
    gibt False zureck, wenn x gerade ist.
    Autor: Daniel Mohr
    Datum: 2012-02-20 (letzte Aenderung)
    Lizenz: GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007"""
    if numpy.floor(x/2.0) == 0:
        ret = False
    else:
        ret = True
    return ret
def dezimal2binaer(d,l):
    z = 0
    ebin = numpy.zeros((l,1),dtype=numpy.uint16)
    rest = numpy.mod(d,2);
    d = (d - rest)/2;
    ebin[z] = rest; z = z + 1
    while d>0:
        # was liefert die ganzzahlige Division von d mit 2?:
        rest = numpy.mod(d,2);
        d = (d - rest)/2;
        ebin[z] = rest; z = z + 1
    return ebin
