import tempfile,struct,array
import numpy,scipy,scipy.sparse,scipy.io

def schreibe_int(pathname,filename,wert):
    fd = open('%s/%s.txt' % (pathname,filename),'w')
    fd.write('%d\n' % wert)
    fd.close()
    fd = open('%s/%s.bin' % (pathname,filename),'wb')
    fd.write(struct.pack('<i',wert))
    fd.close()
    return
def schreibe_double(pathname,filename,wert):
    fd = open('%s/%s.txt' % (pathname,filename),'w')
    fd.write('%e\n' % wert)
    fd.close()
    fd = open('%s/%s.bin' % (pathname,filename),'wb')
    fd.write(struct.pack('<d',wert))
    fd.close()
    return
def schreibe_matrix(pathname,filename,A):
    (n,m) = A.shape
    fd = open('%s/%s.txt' % (pathname,filename),'w')
    fd.write('%d %d\n' % (n,m))
    for i in range(0,n):
        for j in range(0,m):
            fd.write('%d ' % A[i,j])
        fd.write('\n')
    fd.close()
    fd = open('%s/%s.bin' % (pathname,filename),'wb')
    fd.write(struct.pack('<ii',n,m))
    for i in range(0,n):
        for j in range(0,m):
            fd.write(struct.pack('<i',A[i,j]))
    fd.close()
    return
def schreibe_double_matrix(pathname,filename,A):
    (n,m) = A.shape
    fd = open('%s/%s.txt' % (pathname,filename),'w')
    fd.write('%d %d\n' % (n,m))
    for i in range(0,n):
        for j in range(0,m):
            fd.write('%e ' % A[i,j])
        fd.write('\n')
    fd.close()
    fd = open('%s/%s.bin' % (pathname,filename),'wb')
    fd.write(struct.pack('<ii',n,m))
    for i in range(0,n):
        for j in range(0,m):
            fd.write(struct.pack('<d',A[i,j]))
    fd.close()
    return
def schreibe_sparsematrix(pathname,filename,A):
    (n,m) = A.shape
    nz = A.getnnz()
    B = A.tocoo()
    fd = open('%s/%s.txt' % (pathname,filename),'w')
    fd.write('%d %d %d\n' % (n,m,nz))
    for i in range(0,nz):
        fd.write('%d %d %e\n' % (B.row[i],B.col[i],B.data[i]))
    fd.close()
    fd = open('%s/%s.bin' % (pathname,filename),'wb')
    fd.write(struct.pack('<iii',n,m,nz))
    B.row.tofile(fd)
    B.col.tofile(fd)
    B.data.tofile(fd)
    fd.close()
def schreibe_vektor(pathname,filename,b):
    n = len(b)
    fd = open('%s/%s.txt' % (pathname,filename),'w')
    fd.write('%d\n' % (n))
    for i in range(0,n):
        fd.write('%d\n' % b[i])
    fd.close()
    fd = open('%s/%s.bin' % (pathname,filename),'wb')
    fd.write(struct.pack('<i',n))
    for i in range(0,n):
        fd.write(struct.pack('<i',b[i]))
    fd.close()
    return
def schreibe_string(pathname,filename,s):
    fd = open('%s/%s' % (pathname,filename),'w')
    fd.write('%s' % (s))
    fd.close()
    return
def schreibe_problem(dim,knoten,staebe,lager,kraefte,smax,name,redundanz,opt,ungestoerte_kraefte,sort,sigmamin,sigmamax,dichte,zlb,zub,scale_sigma,scale_kraefte):
    tmpdir = tempfile.mkdtemp(prefix='ttrr_tmp_')
    schreibe_int(tmpdir,'dim',dim)
    schreibe_double_matrix(tmpdir,'knoten',knoten)
    schreibe_matrix(tmpdir,'staebe',staebe)
    schreibe_vektor(tmpdir,'lager',lager)
    schreibe_sparsematrix(tmpdir,'kraefte',kraefte)
    schreibe_double(tmpdir,'smax',smax)
    schreibe_string(tmpdir,'info.txt',name)
    schreibe_int(tmpdir,'redundanz',redundanz)
    schreibe_int(tmpdir,'opt',opt)
    schreibe_int(tmpdir,'sort',sort)
    schreibe_double(tmpdir,'sigmamin',sigmamin)
    schreibe_double(tmpdir,'sigmamax',sigmamax)
    schreibe_double(tmpdir,'dichte',dichte)
    schreibe_double(tmpdir,'zlb',zlb)
    schreibe_double(tmpdir,'zub',zub)
    schreibe_double(tmpdir,'scale_sigma',scale_sigma)
    schreibe_double(tmpdir,'scale_kraefte',scale_kraefte)
    if numpy.isscalar(ungestoerte_kraefte) == False:
        schreibe_sparsematrix(tmpdir,'ungestoerte_kraefte',ungestoerte_kraefte)
    return tmpdir
